Bug 210852 - MegaRAID SATA RAID 150-4/6 are not supported 64-bit DMA
Summary: MegaRAID SATA RAID 150-4/6 are not supported 64-bit DMA
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel
Version: 4.4
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
: ---
Assignee: Chip Coldwell
QA Contact: Brian Brock
URL:
Whiteboard:
Depends On:
Blocks: 217097
TreeView+ depends on / blocked
 
Reported: 2006-10-16 08:43 UTC by Vasily Averin
Modified: 2008-01-09 17:31 UTC (History)
7 users (show)

Fixed In Version: RHBA-2007-0304
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2007-05-08 03:50:20 UTC
Target Upstream Version:


Attachments (Terms of Use)
this patch prevents enabling of 64-bit dma on SATA 150-4 and 150-6 devices (745 bytes, patch)
2006-10-16 08:43 UTC, Vasily Averin
no flags Details | Diff
touch up of the previous patch to apply cleanly (761 bytes, patch)
2007-01-25 20:49 UTC, Chip Coldwell
no flags Details | Diff


Links
System ID Private Priority Status Summary Last Updated
Red Hat Product Errata RHBA-2007:0304 0 normal SHIPPED_LIVE Updated kernel packages available for Red Hat Enterprise Linux 4 Update 5 2007-04-28 18:58:50 UTC

Description Vasily Averin 2006-10-16 08:43:16 UTC
Description of problem:
LSI Logic MegaRAID SATA RAID Controllers (150-4 and 150-6) are not works
correctly if more than 4 GB memory installed on the node. According to Ju
Seokmann this hardware is not supported 64 bit DMA. He tried to fix this issue
in 2.20.4.9 version of megaraid_mbox driver, however OpenVZ linux kernel team
has discovered that his patch was wrong.

Version-Release number of selected component (if applicable):
RHEL4u4 2.6.9-42.0.3 kernels

How reproducible:
smp and hugemem kernels hangs or tried to access beyond end of device on the
nodes with more than 4Gb memory and LSI Logic MegaRAID SATA RAID Controllers
(150-4 or 150-6).

Steps to Reproduce:
just try to but kernel on the nodes with more than 4Gb memory and LSI Logic
MegaRAID SATA RAID Controllers (150-4 or 150-6)
  
Actual results:
booting freezed or kernel tried to access beyond end of device

Expected results:
kernel should boot correctly

Additional info:
the same kernels works correctly if they are loaded with "mem=3072M" substring
in kernel commandline.

Comment 1 Vasily Averin 2006-10-16 08:43:16 UTC
Created attachment 138559 [details]
this patch prevents enabling of 64-bit dma on SATA 150-4 and 150-6 devices

Comment 2 Tom Coughlan 2006-10-16 17:56:23 UTC
Chip, Please review. Compare with upstream and RHEL 5. See if we need this fix
there, or there is something to backport. Check with LSI Logic for other updates
to this driver as RHEL 4.5 gets closer. 

Comment 3 Chip Coldwell 2006-11-09 16:30:41 UTC
This patch is in RHEL5.


Comment 5 Chip Coldwell 2007-01-25 20:49:58 UTC
Created attachment 146623 [details]
touch up of the previous patch to apply cleanly

Comment 6 Chip Coldwell 2007-01-25 21:02:19 UTC
commit 031280f6e73d9177c93333c96e37eb05f2522faa
Author: Andrey Mirkin <(amirkin@sw.ru)>
Date:   Mon Oct 16 12:08:43 2006 +0400

    [SCSI] megaraid_{mm,mbox}: 64-bit DMA capability fix
    
    It is known that 2 LSI Logic MegaRAID SATA RAID Controllers (150-4 and
    150-6) don't support 64-bit DMA. Unfortunately currently this check is
    wrong and driver sets 64-bit DMA mode for these devices.
    
    Signed-off-by: Andrey Mirkin <amirkin@sw.ru>
    Acked-by: "Ju, Seokmann" <Seokmann.Ju@lsi.com>
    Signed-off-by: James Bottomley <James.Bottomley@SteelEye.com>

:100644 100644 c0edb66... 7bac86d... M  drivers/scsi/megaraid/megaraid_mbox.c

commit 8741ca71a3f626a56595b88200ebf952ce77ceef
Author: Andrey Mirkin <amirkin@sw.ru>
Date:   Mon Oct 16 12:08:43 2006 +0400

    [PATCH] scsi: megaraid_{mm,mbox}: 64-bit DMA capability fix
    
    It is known that 2 LSI Logic MegaRAID SATA RAID Controllers (150-4 and
    150-6) don't support 64-bit DMA.  Unfortunately currently this check is
    wrong and driver sets 64-bit DMA mode for these devices.
    
    Signed-off-by: Andrey Mirkin <amirkin@sw.ru>
    Acked-by: Vasily Averin <vvs@sw.ru>
    Signed-off-by: Linus Torvalds <torvalds@osdl.org>

:100644 100644 c0edb66... 7bac86d... M  drivers/scsi/megaraid/megaraid_mbox.c

commit fbf6080225a03aa2b3671acacebdf615f1d3f6ba
Author: Ju, Seokmann <Seokmann.Ju@lsil.com>
Date:   Tue Jul 25 08:44:48 2006 -0600

    [SCSI] megaraid_{mm,mbox}: 64-bit DMA capability checker
    
    This patch contains
    - a fix for 64-bit DMA capability check in megaraid_{mm,mbox} driver.
    - includes changes (going back to 32-bit DMA mask if 64-bit DMA mask
    failes) suggested by James with previous patch.
    - addition of SATA 150-4/6 as commented by Vasily Averin.
    
    With patch, the driver access PCIconfiguration space with dedicated
    offset to read a signature. If the signature read, it means that the
    controller has capability to handle 64-bit DMA.
    Without this patch, the driver used to blindly claim 64-bit DMA
    capability.
    The issue has been reported by Vasily Averin [vvs@sw.ru].
    Thank you Vasily for the reporting.
    
    Signed-Off By: Seokmann Ju <seokmann.ju@lsil.com>
    Signed-off-by: James Bottomley <James.Bottomley@SteelEye.com>

:100644 100644 9271513... e671af0... M  drivers/scsi/megaraid/megaraid_mbox.c


Comment 7 Jay Turner 2007-01-30 12:20:29 UTC
QE ack for RHEL4.5.

Comment 8 Andrius Benokraitis 2007-01-30 14:52:41 UTC
Adding LSI for their feedback...

Comment 9 Jason Baron 2007-02-01 19:28:03 UTC
committed in stream U5 build 45. A test kernel with this patch is available from
http://people.redhat.com/~jbaron/rhel4/


Comment 11 Mike Gahagan 2007-04-02 18:46:56 UTC
The patch is in the -52 kernel, still awaiting partner feedback.


Comment 13 Red Hat Bugzilla 2007-05-08 03:50:20 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0304.html


Note You need to log in before you can comment on or make changes to this bug.